Neal Ford Functional Thinking Video Samples
========================================

Samples featured in Neal Ford's O'Reilly video Functional Thinking.

![Functional Thinking cover](http://nealford.com/images/ft_video_cover.png)

# Functional Thinking
Learning the syntax of a new language is easy, but learning to think under a different paradigm is difficult. This video from renowned software architect Neal Ford helps you transition from a Java-writing imperative programmer to a functional programmer, using Java, Clojure and Scala as examples.

Rather than focus on specific language features, Functional Thinking looks at a variety of common practices in OOP languages and then shows you how to solve the same problems using a functional language. For instance, you know how to achieve code-reuse in Java via mechanisms such as inheritance and polymorphism. Code reuse is also possible in functional languages, using high-order functions, composition, and multi-methods.

Ford encourages you to value results over steps, so you can begin to
think like a functional programmer. Expect your mind to be bent, but
you’ll finish with a much better understanding of both the syntax and
semantics of functional languages. This video is ideal for any
experienced programmer.

## Table of Contents
* Introduction (35 minutes)
* Gradually Getting Started (41 minutes)
* Functions (29 minutes)
* Laziness (34 minutes)
* Coupling vs. Composition (25 minutes)
* Functional Data Structures (25 minutes)
* Rethinking Dispatch (20 minutes)
* Summary (25 minutes)

![O'Reilly Books and Videos](http://nealford.com/images/oreilly_books_videos.png)
### [Purchase or stream at O'Reilly's site](http://shop.oreilly.com/product/0636920030393.do)


# Featured Samples

* Number Classifier
  * Java
    * Imperative
    * Slightly more functional
  * Functional Java
  * Totally Lazy
  * Groovy
  * Scala
  * Clojure
* Closures in Groovy
* Memoization in Groovy
* Lazy Lists in Groovy
* Palindromes
  * Groovy
  * Clojure
* Prime numbers
* Parsing XML in Clojure using Zippers
* `Either` and `Option` in Java

